package tpmethod;

public abstract class Car {

    // Atributos de Car que serão modificados durante a execução do algoritmo.
    protected String color;
    protected int bodyWorkVolumesNumber;
    protected String engineType;
    protected String tireType;
    protected String starterMotorType;

    //Template method que executa as etapas do algoritmo. O método é final para que
    //não seja modificado pelas classes que o herdam.
    public final void manufacture() {
        buildCarBodyWork();
        paintCar();
        mountCarParts();
    }

    //Operações abstratas que representam as etapas do algoritmo.
    public abstract void buildCarBodyWork();

    public abstract void paintCar();

    public abstract void mountCarParts();


    public String getColor() {
        return color;
    }

    public int getBodyWorkVolumesNumber() {
        return bodyWorkVolumesNumber;
    }

    public String getEngineType() {
        return engineType;
    }

    public String getTireType() {
        return tireType;
    }

    public String getStarterMotorType() {
        return starterMotorType;
    }

}
